MinutiaeRep = Minutiae:NewModule("MinutiaeRep", "AceConsole-3.0", "AceEvent-3.0")
local tracked, oldName

local function tc(f, r)
	return f:upper()..r:lower()
end

function MinutiaeRep:OnEnable()
	CombatTextSetActiveUnit("player")
	if Minutiae.db.global.dynamic and not Minutiae.db.faction.trackTabard then
		self:RegisterEvent("COMBAT_TEXT_UPDATE")
	end
	if Minutiae.db.global.trackTabard then
		self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
		self:TabardCheck()
	else
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	end
end

function MinutiaeRep:TabardCheck()
	tracked = strlower(GetItemInfo(GetInventoryItemLink("player", 19)))
	self:ScanFactions()
	for i=1, getn(Minutiae.db.global.tabardFactions) do
		if Minutiae.db.global.tabardFactions[i] then
			if strmatch(tracked, Minutiae.db.global.tabardFactions[i]) then
				SetWatchedFactionIndex(i)
				if Minutiae.db.global.showInChat then
					print("|cFFFF0000Minutiae|r: "..string.gsub(tracked, "(%a)([%w_']*)", tc).." reputation tracked")
				end
			elseif strmatch(tracked, "guild") then
				SetWatchedFactionIndex(2)
				if Minutiae.db.global.showInChat then
					print("|cFFFF0000Minutiae|r: "..select(1, GetGuildInfo("player")).." reputation tracked")
				end
			return
			end
		end
	end
end

function MinutiaeRep:PLAYER_EQUIPMENT_CHANGED(_, slot, item)
	if slot == 19 and item == 1 then
		self:TabardCheck()
	end
end

function MinutiaeRep:ScanFactions()
	local factions = {}
	local tabardFactions = {}
	local name, isHeader, isCollapsed
	factions["none"] = 0
	ExpandAllFactionHeaders()
	for i = 0, GetNumFactions() do
		name, _, _, _, _, _, _, _, isHeader = GetFactionInfo(i)
		if not isHeader and name ~= nil then
			factions[string.lower(name)] = i
			tabardFactions[i] = string.lower(name)
		end
	end
	Minutiae.db.global.factions = factions
	Minutiae.db.global.tabardFactions = tabardFactions
end

function MinutiaeRep:ZONE_CHANGED_NEW_AREA()
	self:ScanFactions()
	local faction = Minutiae:GetZone()
	local guildName = ""
	if GetGuildInfo("player") then
		guildName = GetGuildInfo("player")
	end
	if faction == nil and faction ~= strlower(guildName) then
		if Minutiae.db.global.defaultGuild then
			if Minutiae.db.global.showInChat then
				print("|cFFFF0000Minutiae|r: "..GetZoneText()..": no faction tracked; defaulting to Guild Reputation")
			end
		self:ScanFactions()
		SetWatchedFactionIndex(2)
        	end
	else
		local name = "nothing"
		if GetWatchedFactionInfo() then
			name = GetWatchedFactionInfo()
		end
		if faction ~= strlower(name) then
			faction=strlower(faction)
			if Minutiae.db.global.factions[faction] ~= nil then
				SetWatchedFactionIndex(Minutiae.db.global.factions[faction])
				if Minutiae.db.global.showInChat then
					print("|cFFFF0000Minutiae|r: "..GetZoneText()..": "..string.gsub(faction, "(%a)([%w_']*)", tc).." reputation tracked")
				end
			else
				if Minutiae.db.global.showInChat then
	        		        print("|cFFFF0000Minutiae|r: You have not made contact with "..string.gsub(faction, "(%a)([%w_']*)", tc).." yet")
				end
				if Minutiae.db.global.defaultGuild then
					self:ScanFactions()
					SetWatchedFactionIndex(2)
				end
			end
		end
	end
end

function MinutiaeRep:COMBAT_TEXT_UPDATE(_, messageType, faction, amount)
	if messageType ~= "FACTION" then
		return
	elseif amount < 0 and Minutiae.db.global.dynamic and Minutiae.db.global.decrease then
		Minutiae:ChangeBar(_, faction)
	elseif amount > 0 and Minutiae.db.global.dynamic then
		Minutiae:ChangeBar(_, faction)
	end
end
